<?php
namespace nur\sery\wip\schema\types;

use nur\sery\wip\schema\_scalar\ScalarResult;
use nur\sery\wip\schema\_scalar\ScalarSchema;
use nur\sery\wip\schema\Result;
use nur\sery\wip\schema\Schema;

class tfloat extends _tsimple {
  static function ensure_float(&$float): void {
    if (!is_float($float)) $float = floatval($float);
  }

  static function ensure_nfloat(&$float): void {
    if ($float !== null) self::ensure_float($float);
  }

  function isValid($value, ?bool &$normalized=null): bool {
    $normalized = is_float($value);
    if (is_string($value)) $valid = is_numeric(trim($value));
    else $valid = is_scalar($value);
    return $valid;
  }

  /**
   * @var ScalarResult $result
   * @var ScalarSchema $schema
   */
  function verifix(&$value, Result &$result, Schema $schema): bool {
    if (is_float($value)) {
      $result->setNormalized();
      return false;
    } elseif (is_string($value)) {
      $float = trim($value);
      if (is_numeric($float)) $value = floatval($float);
      else return $result->setInvalid($value, $schema);
    } elseif (is_scalar($value)) {
      $value = floatval($value);
    } else {
      return $result->setInvalid($value, $schema);
    }
    $result->setValid();
    return true;
  }

  function format($value, $format=null): string {
    if ($format !== null) return sprintf($format, $value);
    else return strval($value);
  }
}
